package com.iv.flash.api.sound;

import java.io.PrintStream;
import com.iv.flash.parser.*;
import com.iv.flash.util.*;
import com.iv.flash.api.*;

public class SoundStreamBlock extends FlashObject 
{
    public DataMarker data;

    public int getTag() 
    {
        return Tag.SOUNDSTREAMBLOCK;
    }

    public static SoundStreamBlock parse( Parser p ) 
    {
        SoundStreamBlock o = new SoundStreamBlock();

        o.data = new DataMarker( p.getBuf(), p.getPos(), p.getTagEndPos() );       

        return o;
    }

    public void write( FlashOutput fob ) 
    {
        fob.writeTag( getTag(), data.length() );

        data.write(fob);
    }

    public boolean isConstant() 
    {
        return true;
    }

    protected FlashItem copyInto( FlashItem item, ScriptCopier copier ) 
    {
        super.copyInto( item, copier );
        
        ( (SoundStreamBlock) item ).data = data;

        return item;
    }
    public FlashItem getCopy( ScriptCopier copier ) 
    {
        return copyInto( new SoundStreamBlock(), copier );
    }

    public void printContent( PrintStream out, String indent ) 
    {
        out.println( indent + "SoundStreamBlock" );
    }
}
