/*
** Copyright (C) 2001,2002 Sacha Faust <sacha@severus.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 *  $Revision: 1 $
 *  $Modtime: 12/04/02 2:13a $
 *  Soft Version : 2.1
 */

package faust.sacha.web.bot.spider.customlogin;

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.w3c.dom.*;

import org.apache.commons.httpclient.*;
import org.apache.commons.httpclient.methods.*;

import faust.sacha.web.util.*;

public class CustomFormLoginCookie extends CustomLogin {
    
    private List m_stateCookieList;
    
    public CustomFormLoginCookie(URLInfo url, Node config) {
        super(url, config);
        
        //TODO : ADD TO DATAFACTORY
        m_stateCookieList = (List)new ArrayList(0);
        
    }
//------------------------------------------------------------------------------
    public List getStateCookieList(){
        return m_stateCookieList;
    }
//------------------------------------------------------------------------------    
    private void setPostData( String postData ){
        StringTokenizer comboToken = null;
        StringTokenizer paramDataToken = null;
        String tmpStr = null;
        PostMethod tmpMethod = null;
        String paramName = null;
        String paramData = null;
        int pos = 0;
        
        tmpMethod = new PostMethod();
       
        comboToken = new StringTokenizer( postData, "&" );
        
        while( comboToken.hasMoreTokens() ){
            tmpStr = comboToken.nextToken();
            
            paramDataToken = new StringTokenizer(tmpStr, "=");
            if( paramDataToken.countTokens() != 2 ){
                if( WebGlobal.DEBUG )
                    System.err.println("CustomFormLoginCookie::setPostData() : invalid number of tokens in : " + tmpStr);
                
                continue;
            }
            
            paramName = paramDataToken.nextToken();
            paramData = paramDataToken.nextToken();
            
            
            if( WebGlobal.DEBUG )
                System.err.println("CustomFormLoginCookie::setPostData() : paramName : " + paramName + " | paramData : " + paramData);
            
            tmpMethod.addParameter( paramName, paramData );
        }
            
        
        super.m_method = (HttpMethodBase)tmpMethod;
    }
//------------------------------------------------------------------------------    
    public void processConfig() {
        NodeList configNodeList = null;
        Node tmpNode = null;
        String nodeName = null;
        
        try{
            configNodeList = super.m_configNode.getChildNodes();
            
            if( configNodeList == null ){
                if( WebGlobal.DEBUG )
                    System.err.println("CustomFormLoginCookie::processConfig : configNodeList is null");
                
                return;
            }
            
            for( int i = 0; i < configNodeList.getLength(); i++ ){
                tmpNode = configNodeList.item(i);
                
                nodeName = tmpNode.getNodeName();
                
                if( nodeName.equals("POSTDATA") )
                    handlePostData(tmpNode);
                else if( nodeName.equals("COOKIE") )
                    handleCookie(tmpNode);
            }
        }
        catch( Exception e ){
            throw( new IllegalArgumentException("config is invalid : " + e ) );
        }
    }
//------------------------------------------------------------------------------
    private void handlePostData( Node postDataNode ){
        NodeList list = null;
        Node tmpNode = null;
        String postData = null;
        
        try{
            list = postDataNode.getChildNodes();
            
            if( list.getLength() > 0 )
                tmpNode = list.item(0);
            
            postData = tmpNode.getNodeValue().trim();
            setPostData(postData);
            
        }
        catch( Exception e ){
            throw( new IllegalArgumentException("config is invalid : " + e ) );
        }
    }    
//------------------------------------------------------------------------------
    private void handleCookie( Node cookieNode ){
        NodeList list = null;
        Node tmpNode = null;
        String tmpStr = null;
        
        try{
            list = cookieNode.getChildNodes();

            for( int i = 0; i < list.getLength(); i++ ){
                tmpNode = list.item(i);

                tmpStr = tmpNode.getNodeValue().trim();
                handleCookieList(tmpStr);

            }
        }
        catch( Exception e ){
            throw( new IllegalArgumentException("config is invalid : " + e ) );
        }
    }
//------------------------------------------------------------------------------    
    private void handleCookieList( String cookie ){
        BufferedReader reader = null;
        String tmp = null;
        
        try{
            reader = new BufferedReader( new StringReader(cookie) );

            while( (tmp = reader.readLine()) != null ){
                m_stateCookieList.add( (Object) tmp.trim() );
            }
        }
        catch( Exception e ){
            throw( new IllegalArgumentException("config is invalid : " + e ) );
        }
    }    
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
    public static void main( String args[] ){
//        CustomFormLoginCookie f = null;
//        String configTxt = null;
//        
//        WebGlobal.setDebug(true);
//        configTxt = "param1=data1&param2=data2";
//        
//        f = new CustomFormLoginCookie(configTxt);
//        
//        System.err.println("state cookie : " + f.getStateCookieName() );
    }
}
