/*
** Copyright (C) 2001,2002 Sacha Faust <sacha@severus.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 *  $Revision: 1 $
 *  $Modtime: 12/04/02 2:11a $
 *  Soft Version : 2.1
 */
package faust.sacha.web.bot.spider.customlogin;

import javax.xml.parsers.*;
import org.xml.sax.*;
import org.w3c.dom.*;

import org.apache.commons.httpclient.methods.*;
import org.apache.commons.httpclient.*;

import faust.sacha.web.util.*;

public abstract class CustomLogin {

    protected HttpMethodBase m_method;
    protected String m_loaderName;
    protected URLInfo m_url;
    protected Node m_configNode;
    
    public CustomLogin( URLInfo url, Node config ) {
        if( url == null )
            throw( new IllegalArgumentException("url is invalid") );
        if( config == null )
            throw( new IllegalArgumentException("config is invalid") );
        
        m_url = url;
        m_configNode = config;
        m_method = null;
    }
//------------------------------------------------------------------------------
    public abstract void processConfig();
//------------------------------------------------------------------------------    
    public URLInfo getURL(){
        return m_url;
    }
//------------------------------------------------------------------------------        
    public HttpMethodBase getMethod(){
        return m_method;
    }
//------------------------------------------------------------------------------    
    public String getLoaderName(){
        return m_loaderName;
    }
//------------------------------------------------------------------------------        
    
}
