/*
 ** Copyright (C) 2001,2002 Sacha Faust <sacha@severus.org>
 **
 ** This program is free software; you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation; either version 2 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 *  $Revision: 1 $
 *  $Modtime: 12/02/02 10:08a $
 *  Soft Version : 2.1
 */
package faust.sacha.web.bot.spider.customlogin;

import org.apache.commons.httpclient.*;

public abstract class CustomLoginLoader {
    
    protected CustomLogin m_login;
    protected HttpState m_state;
    
    public CustomLoginLoader( CustomLogin login ){
        if( login == null )
            throw( new IllegalArgumentException("login is invalid") );
        
        m_state = new HttpState();
        m_login = login;
    }
//------------------------------------------------------------------------------
    public HttpState getHttpState(){
        return m_state;
    }
//------------------------------------------------------------------------------
    public boolean process(){
        return processLogin();
    }
//------------------------------------------------------------------------------    
    protected abstract boolean processLogin();
//------------------------------------------------------------------------------    
}
