/*
** Copyright (C) 2001,2002, 2003 Sacha Faust <sacha@severus.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 *  $Revision: 6 $
 *  $Modtime: 3/19/03 12:21a $
 *  Soft Version : 2.1
 */
package faust.sacha.web.bot.spider.data;

import java.util.*;

import faust.sacha.web.util.HTMLFile;
import faust.sacha.web.data.URLData;

public class FileData implements ElementInfoInt {

    private HTMLFile m_fileInfo;
    private URLData m_parentURL;

    public FileData( HTMLFile file, URLData parentURL ) {
        m_fileInfo = file;
        m_parentURL = parentURL;
    }
//------------------------------------------------------------------------------
    public HTMLFile getFileData(){
        return m_fileInfo;
    }
//------------------------------------------------------------------------------
    public URLData getParentURL(){
        return m_parentURL;
    }
//------------------------------------------------------------------------------
    public List getURLList(){
        return (List)m_fileInfo.getURLList();
    }
//------------------------------------------------------------------------------
    public List getEmailList() {
        return (List)m_fileInfo.getEmailFound();
    }
//------------------------------------------------------------------------------
    public List getMiscURLList() {
        return (List)m_fileInfo.getMiscFound();
    }
//------------------------------------------------------------------------------
    public List getCommentList() {
        return (List)m_fileInfo.getComments();
    }

//------------------------------------------------------------------------------
}
