/*
** Copyright (C) 2001,2002, 2003 Sacha Faust <sacha@severus.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 *  $Revision: 4 $
 *  $Modtime: 3/19/03 12:21a $
 *  Soft Version : 2.1
 */
package faust.sacha.web.bot.spider.data;


public class Queue {

    private QueueNode m_head;
    private QueueNode m_tail;
    private long m_size;
    private Object m_queueMutex;

    public Queue() {
        m_head = null;
        m_tail = null;
        m_size = 0;
        m_queueMutex = new Object();
    }
//------------------------------------------------------------------------------
    public void add( Object object ){
        QueueNode node = null;


        if( object == null )
            return;

        node = new QueueNode(object);

        synchronized( m_queueMutex ){
            if( m_size == 0 ){
                m_head = node;
                m_tail = node;
            }
            else{
                m_tail.next = node;
                node.prev = m_tail;
                m_tail = node;
            }

            m_size++;
        }
    }
//------------------------------------------------------------------------------
    public Object get(){
        Object ojb = null;

        synchronized( m_queueMutex ){
            if( isEmpty() )
                return null;

            ojb = m_head.object;

            if( m_size == 1 ){
                m_head = null;
                m_tail = null;
            }
            else{
                m_head = m_head.next;
                m_head.prev = null;
            }

            m_size--;

            return ojb;
        }
    }
//------------------------------------------------------------------------------
    public boolean isEmpty(){
        synchronized( m_queueMutex ){
            return (m_size == 0) ? true : false;
        }
    }
//------------------------------------------------------------------------------
//    public Object get(){
//        Object ojb = null;
//        int nbRetries = 0;
//
//        while( true ){
//
//            /*
//             *  We check to see if there is element in the queue
//             *  if there is, we return the head
//             *  if not, we wait for 2 sec only once, if there is still
//             *  no element, we return null
//             */
//            synchronized( m_queueMutex ){
//                if( m_size != 0 ){
//                    ojb = m_head.object;
//
//                    if( m_size == 1 ){
//                        m_head = null;
//                        m_tail = null;
//                    }
//                    else{
//                        m_head = m_head.next;
//                        m_head.prev = null;
//                    }
//
//                    m_size--;
//
//                    System.err.println("queue : get : " + ojb.toString() );
//                    return ojb;
//                }
//                else if( nbRetries > 0 )
//                    return null;
//            }
//
//            /*
//             *  If we reach here , it means that m_size was 0
//             *  we wait once to see if there is going to be some additional
//             *  stuff. We wait for 1 second before we return null
//             */
//            try{
//                nbRetries++;
//                wait(1000);
//            }
//            catch( InterruptedException intEx ){
//            }
//        }
//    }
}
//
////------------------------------------------------------------------------------
////------------------------------------------------------------------------------
////------------------------------------------------------------------------------
class QueueNode {

    public QueueNode prev;
    public QueueNode next;
    public Object object;

    public QueueNode( Object object ){
        this.object = object;
        prev = null;
        next = null;
    }

    public QueueNode( Object object, QueueNode previous, QueueNode next ){
        this.object = object;
        prev = previous;
        next = next;
    }
}
