/*
** Copyright (C) 2001,2002, 2003 Sacha Faust <sacha@severus.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 *  $Revision: $
 *  $Modtime: $
 *  Soft Version : 2.1
 */
package faust.sacha.web.bot.spider.data;

import java.util.*;

import faust.sacha.web.util.*;

public class URLKeyword {
    private URLInfo m_url;
    private List m_keywordList;

    public URLKeyword(URLInfo url, List keywordList ) {
        if( url == null )
            throw( new IllegalArgumentException("url is invalid") );
        if( keywordList == null )
            throw( new IllegalArgumentException("keywordList is invalid") );

        m_url = url;
        m_keywordList = keywordList;
    }
//------------------------------------------------------------------------------
    public void addKeyword( String keyword ){
        if( (keyword == null) || ("".equals(keyword)) ){
            if( WebGlobal.DEBUG )
                System.err.println("URLKeyword::addKeyword() : keyword is wrong : " + keyword);

            return;
        }

        m_keywordList.add( (Object)keyword );
    }
//------------------------------------------------------------------------------
    public int getNBKeywords(){
        return m_keywordList.size();
    }
//------------------------------------------------------------------------------
    public URLInfo getURL(){
        return m_url;
    }
//------------------------------------------------------------------------------
    public List getKeywordList(){
        return m_keywordList;
    }
//------------------------------------------------------------------------------
}
