/*
** Copyright (C) 2001,2002 Sacha Faust <sacha@severus.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 *  $Revision: 1 $
 *  $Modtime: 12/19/02 12:48a $
 *  Soft Version : 2.1
 */
package faust.sacha.web.bot.spider.state;

import java.util.*;
import org.apache.commons.httpclient.HttpState;

public class HttpStateManager {
    
    private static Hashtable m_siteStateTable = new Hashtable();
    
    public HttpStateManager() {
        synchronized( m_siteStateTable ){
            m_siteStateTable = new Hashtable();
        }
    }
//------------------------------------------------------------------------------
    private static void setStateList(){
        synchronized( m_siteStateTable ){
            if( m_siteStateTable == null )
                m_siteStateTable = new Hashtable();
        }
    }
    
//------------------------------------------------------------------------------    
    public static void addSiteState( String siteName, HttpState state ){

        synchronized( m_siteStateTable ){
            setStateList();
            m_siteStateTable.put( (Object)siteName, (Object)state );
        }
    }
//------------------------------------------------------------------------------
    public static HttpState getSiteState( String siteName ){
        synchronized( m_siteStateTable ){
            setStateList();
            return (HttpState)m_siteStateTable.get( (Object)siteName );
        }
    }
//------------------------------------------------------------------------------    
}
